include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
include "nat.ma".
definition sameF_upto : \forall A : Type[0] . nat -> (nat -> A) -> (nat -> A) -> Prop := \lambda A : Type[0]. \lambda k : nat. \lambda f : nat -> A. \lambda g : nat -> A. \forall (i:nat). ((lt)  i k) -> (eq) (A) (f i) (g i).
definition sameF_p : \forall A : Type[0] . nat -> (nat -> bool) -> (nat -> A) -> (nat -> A) -> Prop := \lambda A : Type[0]. \lambda k : nat. \lambda p : nat -> bool. \lambda f : nat -> A. \lambda g : nat -> A. \forall (i:nat). ((lt)  i k) -> ((eq) (bool) (p i) (true) ) -> (eq) (A) (f i) (g i).
definition sameF_upto_le : \forall A. \forall (f:nat -> A). \forall (g:nat -> A). \forall (n:nat). \forall (m:nat). ((le)  n m) -> ((sameF_upto) (A) m f g) -> (sameF_upto) (A) n f g := \lambda A : Type[0]. \lambda f : nat -> A. \lambda g : nat -> A. \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (\lambda samef : (sameF_upto) (A) m f g. (\lambda i : nat. \lambda ltin : (lt)  i n. (((samef) (i)) ((((((lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))))).
definition sameF_p_le : \forall A. \forall (p:nat -> bool). \forall (f:nat -> A). \forall (g:nat -> A). \forall (n:nat). \forall (m:nat). ((le)  n m) -> ((sameF_p) (A) m p f g) -> (sameF_p) (A) n p f g := \lambda A : Type[0]. \lambda p : nat -> bool. \lambda f : nat -> A. \lambda g : nat -> A. \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (\lambda samef : (sameF_p) (A) m p f g. (\lambda i : nat. \lambda ltin : (lt)  i n. (\lambda pi : (eq) (bool) (p i) (true) . ((((samef) (i)) ((((((lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))) (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) (p i)) (pi)))))).
axiom bigop : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom bigop_body : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom axiom_bigop_O : \forall H. (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) (O) ) ((bigop_body) (H) (O) ).
definition eq_bigop_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) (O) ) ((bigop_body) (H) (O) ) := \lambda H : Type[0]. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) (O) )) ((bigop_body) (H) (O) )) ((axiom_bigop_O) (H)).
definition sym_eq_bigop_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) ((bigop) (H) (O) ) := \lambda H : Type[0]. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) (O) )) ((bigop_body) (H) (O) )) ((eq_bigop_O) (H)).
axiom axiom_bigop_S : \forall H. \forall (n:nat). (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) ((S)  n)) ((bigop_body) (H) ((S)  n)).
definition eq_bigop_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) ((S)  n)) ((bigop_body) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) ((S)  n))) ((bigop_body) (H) ((S)  n))) (((axiom_bigop_S) (H)) (n)).
definition sym_eq_bigop_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) ((bigop) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) ((S)  n))) ((bigop_body) (H) ((S)  n))) (((eq_bigop_S) (H)) (n)).
axiom axiom_bigop_body_O : \forall H. (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil).
definition eq_bigop_body_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil) := \lambda H : Type[0]. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) (O) )) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil)) ((axiom_bigop_body_O) (H)).
definition sym_eq_bigop_body_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil) ((bigop_body) (H) (O) ) := \lambda H : Type[0]. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) (O) )) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil)) ((eq_bigop_body_O) (H)).
axiom axiom_bigop_body_S : \forall H. \forall (n:nat). (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)).
definition eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) := \lambda H : Type[0]. \lambda n : nat. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
definition sym_eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) ((bigop_body) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
definition same_bigop : \forall B. \forall (k:nat). \forall (p1:nat -> bool). \forall (p2:nat -> bool). \forall (nil:B). \forall (op:B -> B -> B). \forall (f:nat -> B). \forall (g:nat -> B). ((sameF_upto) (bool) k p1 p2) -> ((sameF_p) (B) k p1 f g) -> (eq) (B) ((bigop) (B) k (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) k (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) := \lambda B : Type[0]. \lambda k : nat. \lambda p1 : nat -> bool. \lambda p2 : nat -> bool. \lambda nil : B. \lambda op : B -> B -> B. \lambda f : nat -> B. \lambda g : nat -> B. ((((nat_ind) (\lambda j_x_365 : nat. ((sameF_upto) (bool) j_x_365 p1 p2) -> ((sameF_p) (B) j_x_365 p1 f g) -> (eq) (B) ((bigop) (B) j_x_365 (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) j_x_365 (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((sym_eq_bigop_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((sym_eq_bigop_body_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((eq_bigop_body_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))) ((((eq_bigop_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))) (\lambda auto : (sameF_upto) (bool) (O)  p1 p2. (\lambda auto' : (sameF_p) (B) (O)  p1 f g. (((refl) (B)) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))))))))) (\lambda n : nat. ((((sym_eq_bigop_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) ((bigop) (B) ((S)  n) (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop_body) (B) ((S)  n) (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop_body) (B) ((S)  n) (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (((\lambda p : nat -> bool. \lambda nil0 : B. \lambda op0 : B -> B -> B. \lambda f0 : nat -> B. (match_bool_type) (B) (op0 (f0 n) ((bigop) (B) n p nil0 op0 f0)) ((bigop) (B) n p nil0 op0 f0) (p n)) (\lambda i : nat. p1 i)) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (\lambda Hind : ((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)). (\lambda samep : (sameF_upto) (bool) ((S)  n) p1 p2. (\lambda samef : (sameF_p) (B) ((S)  n) p1 f g. (((((((eq_ind_r) (B)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda x : B. (eq) (B) ((match_bool_type) (B) (op (f n) x) x (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p2 n)))) (((((((eq_ind) (bool)) (p1 n)) (\lambda x_1 : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x_1))) (((((((match_Or_prop) ((eq) (bool) (p1 n) (true) )) ((eq) (bool) (p1 n) (false) )) ((eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)))) (\lambda H1 : (eq) (bool) (p1 n) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x))) ((((((sym_eq_match_bool_type_true) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) y ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (true) ))) ((((((sym_eq_match_bool_type_true) (B)) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) y)) (((((((eq_ind) (B)) (f n)) (\lambda x_1 : B. (eq) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (op x_1 ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))))) (((refl) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))))) (g n)) ((((samef) (n)) ((le_n) ((S)  n))) (H1)))))) (p1 n)) (H1)))) (\lambda H1 : (eq) (bool) (p1 n) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x))) ((((((sym_eq_match_bool_type_false) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) y ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (false) ))) ((((((sym_eq_match_bool_type_false) (B)) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) y)) (((refl) (B)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))))) (p1 n)) (H1)))) ((true_or_false) (p1 n)))) (p2 n)) (((samep) (n)) ((le_n) ((S)  n))))) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i))) (((Hind) ((((((((sameF_upto_le) (bool)) (p1)) (p2)) (n)) ((S)  n)) (((((eq_coerc) ((le)  ((pred)  ((S)  n)) ((S)  n))) ((le)  n ((S)  n))) ((le_pred_n) ((S)  n))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((S)  n)) ((le)  n ((S)  n)))) (((refl) (Prop)) ((le)  n ((S)  n)))) ((pred)  ((S)  n))) ((pred_Sn) (n))))) (samep))) (((((((((sameF_p_le) (B)) (p1)) (f)) (g)) (n)) ((S)  n)) (((((eq_coerc) ((le)  ((pred)  ((S)  n)) ((S)  n))) ((le)  n ((S)  n))) ((le_pred_n) ((S)  n))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((S)  n)) ((le)  n ((S)  n)))) (((refl) (Prop)) ((le)  n ((S)  n)))) ((pred)  ((S)  n))) ((pred_Sn) (n))))) (samef)))))))))))) (k).
